#include<stdlib.h>
#include<stdio.h>

struct nimistu_element {
   int number;
   struct nimistu_element * jrgm;
};

/*deklareerime uue tbi nimega ELEMENT*/
typedef struct nimistu_element element;

/*funktsioonide prototbid*/
void ekraanile(element *e);
void vabasta_malu(element *e);

/*funktsioon MAIN*/
int main(void)
{
    element *see, *jargmine; /*deklareerime viidad ELEMENT-tpi struktuurile*/
    FILE *numbrid;
    
    int numbrite_arv=0; /*tisarvuline muutuja  - kasutame seda failis olevate numbrite arvu mramiseks*/
    int i=0;
    
    numbrid=fopen("numbrid.txt","r");
    
    jargmine=NULL; /*algvrtustame viida*/ 
    
    /*loeme failis olevad numbrid*/
    while(!feof(numbrid))
    {
        /*eraldame mlu ELEMENT tpi struktuurile*/
        see=(element*)malloc(sizeof(element));

        /*loeme failist numbri*/
        fscanf(numbrid, "%d", &see->number);
        
        /*trkime numbri ekraanile koos jrjekorranumbriga*/
        printf("%d %d\n", i, see->number);
        
        /*uuendame jrgmise elemendi aadressi vrtust*/   
        see->jrgm  = jargmine;

        i++;  /*suurendame loendurit*/
        jargmine=see; /*uuendame viida jargmine vrtust*/                 
    }
    printf("Kokku failis numbreid: %d\n", i);
   
    /*vljastame nimistu ekraanile*/   
    ekraanile (jargmine);
   
    /*vabastame kogu eraldatud mlu*/
    vabasta_malu(jargmine);
    
    return 0;
}

/*funktsioon nimistu vljastamiseks ekraanile; parameeter - nimistu viimane element*/
void ekraanile(element *e)
{
     int i=0;
     
     while (e)
     {
          printf("%d: %d\n", i, e->number);
          i++;
          e=e->jrgm; /*"aktiveerime" jrgmise elemendi*/
     }
}   

/*funktsioon nimistu mlu vabastamiseks; parameeter - nimistu viimane element*/
void vabasta_malu(element *e)
{
   element *abi;

   while (e!= NULL)
   {
          abi = e->jrgm;
          free(e);
          e = abi;
   }
}  
